'_____________________________________________________________________________________
'
' Omrdesansvarig: Markus Sigonius
' Senast strre frndring: december 2020 av Markus Sigonius
' Senast uppdaterad: 2021-01-22
'
' Syfte: Den hr filen tar fram underlag fr att berkna de automatiska stabilisatorerna i Sverige (Working Paper)
'_____________________________________________________________________________________


Mode Quiet
Close @All
LogMode(filename="k:\LoggEviews.txt", autosave=on, ts, clearfile) error LogMsg

'_____________________________________________________________________________________

'1. Instllningar/frbererdeler
StatusLine 1. Instllningar/frbererdeler

' Tysta och stng
Mode Quiet
Close @All

'1.A Definiera r
%perFUA = "1980"  'Frsta r fr berkningarna i huvudscenariot
%perSUA = "2019"  'Sista r fr berkningarna i huvudscenariot


'1.B Paths och arkivbanker
%Pathautstab = "G:\PRO\Gemensam\Projekt\AutomatiskaStabilisatorer\WP\Hemsida\" ' Justera till rtt "path"
WfOpen {%Pathautstab}automaticstabilizers.wf1

'1.D Dokument fr att spara resultaten
Spool res

'_____________________________________________________________________________________

'2. Listar serier som anvnds i berkningarna
StatusLine 2. Listar serier som anvnds i berkningarna

'Makrovariabler
'Arali1574 Gapp Nbnpmpl U_jmv Nbnpmpfd
'Nbonlfvl Nfvnfpl Nfvmpl

'Offentliga finanser (skatter, lnesumma och ersttningar vid arbetslshet)
'Dses Dshk Dshs Dsht Dsto Dsus Eaho Faha Faht Faua  Kapsk Kapred Lsth Psto Pstsivlon Putot Sato Skto Stsharbm stshbobi strhsocbi

Smpl %perFUA %perSUA
Series Bnpalpot = nbnpmpl/(1 + gapp/100)  'Berknar potentiell BNP i lpande pris
Series n = 1/nbnpmpl*100  'Fr att underltta berkningen av BNP-andelar


'2.B Berknar lnesumman/vinstandelen
Smpl %perFUA %perSUA
Series PsKI = (nbonlfvl * (nfvnfpl/nfvmpl)) * (nbnpmpl/100) 'PS = Profit share
Series LsKI = nbnpmpl-Pski 'LS = Labour share

' BNP-gap frn OECD samt berkna HP-filtrerat BNP-gap och jmviktsarbetslshet.
'GapOECD

Smpl 1980 2019
For %x Nbnpmpfd Arali1574
		Hpf(lambda=100) {%x} trend{%x}
Next

Smpl 1980 2019
Series GapNbnpmpfd= (nbnpmpfd-trendnbnpmpfd)/trendnbnpmpfd*100
Series arali1574_8019hp = trendarali1574

'_____________________________________________________________________________________

'3. Estimerar lnesummans elasticitet i frhllande till BNP-gapet
StatusLine 3. Estimerar lnesummans elasticitet i frhllande till BNP-gapet


Smpl 1982 2007
Equation LS_8207.ls(Cov="hac") d(Log(lski/bnpalpot)) C d(Log(nbnpmpl/bnpalpot))

Smpl 1982 2019
Equation LS_8219.ls(Cov="hac") d(Log(lski/bnpalpot)) C d(Log(nbnpmpl/bnpalpot))

Smpl 1990 2007
Equation LS_9007.ls(Cov="hac") d(Log(lski/bnpalpot)) C d(Log(nbnpmpl/bnpalpot))

Smpl 1990 2019
Equation LS_9019.ls(Cov="hac") d(Log(lski/bnpalpot)) C d(Log(nbnpmpl/bnpalpot))

Smpl 1998 2019
Equation LS_9819.ls(Cov="hac") d(Log(lski/bnpalpot)) C d(Log(nbnpmpl/bnpalpot))

Smpl 2008 2019
Equation LS_0819.ls(Cov="hac") d(Log(lski/bnpalpot)) C d(Log(nbnpmpl/bnpalpot))

res.add ls_8207 ls_8219 ls_9007 ls_9019 ls_9819 LS_0819


'3.B. SKattningar dr ytterligare ett r lggs till
Equation eq
Series bta_ctemp
Series bta_setemp

!rowcounter=1
For !year=1990 To 2019
	Smpl 1980 !year
	eq.ls(Cov="hac") d(Log(lski/bnpalpot)) C d(Log(nbnpmpl/bnpalpot))
	bta_ctemp(!rowcounter,2) = eq.@coefs(2)
	bta_setemp(!rowcounter,3) = eq.@stderrs(2)
	!rowcounter = !rowcounter+1
Next

Series bta_c = bta_ctemp(-10)
Series bta_se =bta_setemp(-10)
Delete bta_ctemp bta_setemp

Series bta_lb = bta_c - bta_se
Series bta_ub = bta_c + bta_se


'Quandt-Andrews Breakpoint Test
Smpl 1980 2019
Equation LS_break.ls(Cov="hac") d(Log(lski/bnpalpot)) C d(Log(nbnpmpl/bnpalpot))

ls_break.ubreak(lfname=ubteststat) 15


'3.C Skattningar med en annan definition av lnesumman och vinstandelen. Utgr ifrn lnesumman frn nationalrkenskaperna

'Bolagsskatten i Sverige
Smpl 1980 1984
Series CORPTAX = 0.40
Smpl 1985 1989
Series CORPTAX = 0.52
Smpl 1990 1990
Series CORPTAX = 0.40
Smpl 1991 1993
Series CORPTAX = 0.30
Smpl 1994 2008
Series CORPTAX = 0.28
Smpl 2009 2012
Series CORPTAX = 0.263
Smpl 2013 2018
Series CORPTAX = 0.22
Smpl 2019 2019
Series CORPTAX = 0.214

Smpl 1980 2019
Series Bolv = (Dses+dsus)/Corptax     ' Implicit skattebas fr fretagsskatter

' Berkna nya elasticiteter
Smpl 1998 2019
Equation LS_9819lon.ls(Cov="hac") d(Log(lsth/bnpalpot)) C d(Log(nbnpmpl/bnpalpot))
Equation LS_9819ps.ls(Cov="hac") d(Log(bolv/bnpalpot)) C d(Log(nbnpmpl/bnpalpot))

'_____________________________________________________________________________________

'4. Estimerar arbetslshetsgapets elasticitet i frhllande till BNP-gapet
StatusLine 4. Estimerar arbetslshetsgapets elasticitet i frhllande till BNP-gapet

Smpl 1982 2007
Equation AG_8207.ls(Cov="hac") d(Log(arali1574/u_jmv)) C d(Log(nbnpmpl/bnpalpot))

Smpl 1982 2019
Equation AG_8219.ls(Cov="hac") d(Log(arali1574/u_jmv)) C d(Log(nbnpmpl/bnpalpot))

Smpl 1990 2007
Equation AG_9007.ls(Cov="hac") d(Log(arali1574/u_jmv)) C d(Log(nbnpmpl/bnpalpot))

Smpl 1990 2019
Equation AG_9019.ls(Cov="hac") d(Log(arali1574/u_jmv)) C d(Log(nbnpmpl/bnpalpot))

Smpl 1998 2019
Equation AG_9819.ls(Cov="hac") d(Log(arali1574/u_jmv)) C d(Log(nbnpmpl/bnpalpot))

Smpl 2008 2019
Equation AG_0819.ls(Cov="hac") d(Log(arali1574/u_jmv)) C d(Log(nbnpmpl/bnpalpot))

res.add ag_8207 ag_8219 ag_9007 ag_9019 ag_9819 AG_0819

'_____________________________________________________________________________________

'5. Estimerar offentliga utgifters elasticitet i frhllande till arbetslshetsgapet
StatusLine 5. Estimerar offentliga utgifters elasticitet i frhllande till arbetslshetsgapet

' Ta fram motsvarande Table 3.7 i Flodn (2009)
Smpl 1998 2020
Group T37_egen 0 stsharbm/putot*100 0 arali1574 u_jmv (u_jmv/arali1574) 0

'Inkludera bostadsbidrag till familjer och socialbidrag/frsrjningsstd som arbetslshetsrelaterade transfereringar
Group T37_utokad 0 (stsharbm+stshbobi+strhsocbi)/putot*100 0 arali1574 u_jmv (u_jmv/arali1574) 0

res.add T37_egen T37_utokad

'_____________________________________________________________________________________

'6. Berknar andelar av BNP enligt Table 3.9 i Flodn (2009)
StatusLine 6. Berknar andelar av BNP enligt Table 3.9 i Flodn (2009)

Series SkattLon = dshs-(kapsk-kapred)+dshk
Series SkattSoc = faha+faua+eaho+pstsivlon
Series SkattBol = dses+dsus
Series SkattOvr = skto-((dshs-(kapsk-kapred)+dshk)+(faha+faua+eaho+pstsivlon)+(dses+dsus))


Group T39 skattLon*n skattSoc*n skattBol*n skattOvr*n putot*n

res.add T39

'_____________________________________________________________________________________


'7. Berkna semi-automatiska stabilisatorer dr utgiften fr arbetsmarknadspolitiska program ingr
StatusLine 7. Berkna semi-automatiska stabilisatorer dr utgiften fr arbetsmarknadspolitiska program ingr

'Data ver kostnad fr arbetsmarknadspolitiska program (kostnad respektive antal)
'Smpl 1998 2018
'amppexskatt  amppantal

'Berkna korrelationen mellan amppantal och bnpgap?
Smpl 1998 2018
group amantal amppantal gapp
amantal.corr
Equation korr_amantal.ls(Cov="hac") amppantal C Gapp

group amantalett amppantal gapp(-1)
amantalett.corr
Equation korr_amantalett.ls(Cov="hac") amppantal C Gapp(-1)

'Berkna korrelationen mellan amppexskatt och bnpgap?
Equation korr_ampp_gap.ls(Cov="hac") amppexskatt C Gapp(-1)

'Berkna korrelationen mellan amppexskatt och arbetslsheten?
Smpl 1998 2018
Equation e_exskatt.ls(Cov="hac") amppexskatt C arali1574 arali1574(-1)
e_exskatt.forecast f_exskatt

Equation e_exskattNY.ls(Cov="hac") amppexskatt C @d(arali1574) @d(arali1574(-1))
e_exskattNY.forecast f_exskattNY

plot amppexskatt f_exskatt f_exskattNY


Group T37_ampl 0 stsharbm/putot*100 f_exskatt/putot*100 0 arali1574 u_jmv (u_jmv/arali1574) 0
Group T37_all stsharbm/putot*100 (stshbobi+strhsocbi)/putot*100 f_exskatt/putot*100

res.add T37_ampl


'_____________________________________________________________________________________


'8. Berkna konfidensintervallet kring skattningarna
StatusLine 8. Berkna konfidensintervallet kring skattningarna


'Lser in elasticitet mellan skatteinkomster och skattebas (kopierad frn Excelfil)
Smpl 1998 2019
Series elas_skattlon = 0
elas_skattlon.fill(o=1998) _
1.26420267488035, 	1.23653718168085, 	1.24709814138137, 	1.25884873393008, 	1.27176887877678, 	1.29990618289271, 	1.298595915729, 	1.3234790933096, 	1.34480386547207, 	1.44431213508441, 	1.4729485979225, 	1.47367980761515, 	1.49900877805162, 	1.49311376376634, 	1.48536984549994, 	1.47875616140461, 	1.49276351291228, 	1.48843889806831, 	1.50425748939664, 	1.50453497485403, 	1.49882208183597, 	1.50206026576622

'Lser in elasticitet mellan primra utgifter och arbetslshetsgapet (kopierad frn Excelfil)
Smpl 1998 2019
Series elas_prim = 0
elas_prim.fill(o=1998) _
2.49978946942557, 	2.58656555189878, 	2.79830495313458, 	2.50157134153712, 	2.34233682118589, 	2.19295410780072, 	2.0705793416816, 	1.88876485792925, 	1.8217193019601, 	1.43891818131084, 	1.08889244004322, 	1.21988714865441, 	1.26338283255993, 	1.1709854721448, 	1.1799537017303, 	1.19690630694582, 	1.10432231296142, 	1.12296294767123, 	1.15558604994748, 	1.15550403302017, 	1.09990279713445, 	1.00623917764778

'Berknar konfidensintervallet
Smpl 1998 2019
Series k1 = (elas_skattlon*Skattlon*n + 1*Skattsoc*n -0.72/0.28* Skattbol*n)
Series k2 = -(elas_prim/100 *Putot*n)

Smpl 1982 2019
series ygap = d(Log(nbnpmpl/bnpalpot))
series wygap = d(Log(lski/bnpalpot))
Series ugap = d(Log(arali1574/u_jmv))

' Skapa matrisen X
Matrix X
series intercept = 1
group X_group intercept ygap
Stom(X_group, X)

' Skatta en multivariat regression med OLS
system sys1
sys1.append wygap=c(1)+c(2)*ygap
sys1.append ugap=c(3)+c(4)*ygap
sys1.ls

Scalar betatauw = sys1.@coefs(2)
Scalar betagamma = sys1.@coefs(4)

'Berkna storleken p de automatiska stabilisatorerna (hnsyn till att vissa elasticiteter r 1)
Series Alpha = betatauw*k1 + 1/0.28*Skattbol*n + Skattovr*n + k2*betagamma

' Ta fram Sigma-hatt
Matrix Sigma = sys1.@residcov
scalar sigma1 = Sigma(1,1)
scalar sigma2 = Sigma(2,2)
scalar sigma12 = Sigma(1,2)

' Ta fram element (2,2) av (X'X)^-1
Matrix xx = @transpose(X) * X
Matrix xx_inv = @inverse(xx)
scalar xx_inv_22 = xx_inv(2,2)

' Ta fram en serie fr variansen
' Ta ocks fram "komponenterna" fr att frst varfr variansen r stor
series varians = (sigma1 * k1^2 + sigma2 * k2^2 + 2 * k1*k2 * sigma12) * xx_inv_22
series varians1 = sigma1 * k1^2 * xx_inv_22
series varians2 = sigma2 * k2^2 * xx_inv_22
series varians3 = 2 * k1*k2 * sigma12 * xx_inv_22

group varianser varians varians1 varians2 varians3
'varianser.line

'Ta fram vre och undre konfidensintervall
Series konfint_undre = Alpha -1 * @sqrt(varians)
Series konfint_ovre = Alpha + 1 * @sqrt(varians)

'_____________________________________________________________________________________

' Sparar workfiles
WfSave {%Pathautstab}automaticstabilizers.wf1
StatusLine Klar.